local mod = ...



-- Starting Tile and Plantable list
mod:override({
    Id = "DEFAULT_BALANCING",
    StartingTileResourceRequirement = {
        {
            Resource = "BERRIES",
            Quantity = 1
        },
        {
            Resource = "STONE",
            Quantity = 1
        },
        {
            Resource = "WOOD",
            Quantity = 10
        },
    },
    PlantableList = {
        "PLANTABLE_DESERT_TREE_DATE",
        "PLANTABLE_DESERT_TREE_CANE",
        "PLANTABLE_DESERT_TREE_PALM1",
        "PLANTABLE_DESERT_TREE_PALM2",
    }
})



-- -- Set Fertility for farming to negative by default ---------------------------------------------------------------
-- -- This has no effect on farming
-- mod:override({
--     Id = "DESIRABILITY_FERTILITY",
--     DefaultValue = -50
-- })



-- -- Change tree fertility impact radius ---------------------------------------------------------------
-- mod:override({
--     Id = "DEFAULT_BALANCING",
--     TreeFertilityImpactSoftRadius = -1,
-- })



-- -- Add fertility to water sources ---------------------------------------------------------------
-- mod:override({
--     Id = "BUILDING_PART_WELL",
--     DesirabilityModifiers = {
--         Action = "APPEND",
--         {
--             Desirability = "DESIRABILITY_FERTILITY",
--             Type = DESIRABILITY_EFFECT_TYPE.ADD,
--             Radius = 80,
--             Value = 2.0
--         },
--     },
-- })

-- mod:override({
--     Id = "WELLBALANCING_PART",
--     DesirabilityModifiers = {
--         Action = "APPEND",
--         {
--             Desirability = "DESIRABILITY_FERTILITY",
--             Type = DESIRABILITY_EFFECT_TYPE.ADD,
--             Radius = 80,
--             Value = 2.0
--         },
--     }
-- })

-- mod:override({
--     Id = "WELLBALANCING_PART2",
--     DesirabilityModifiers = {
--         Action = "APPEND",
--         {
--             Desirability = "DESIRABILITY_FERTILITY",
--             Type = DESIRABILITY_EFFECT_TYPE.ADD,
--             Radius = 80,
--             Value = 4.0
--         },
--     },
-- })



-- Change Berries to Dates ---------------------------------------------------------------
mod:override({
    Id = "BERRIES",
    ResourceName = "RESOURCE_NAME_DATE",
    VillagerBuyingPrice = { Resource = "GOLD_COINS", Quantity = 6 }
})



-- Remove extraction zone requirement for Foragers ---------------------------------------------------------------
mod:override({
    Id = "GATHERER",
    RelatedZone = ""
})



-- Assets
mod:registerAssetId("models/Desert1.fbx/Prefab/TreeDate", "PREFAB_DESERT_TREE_DATE")
mod:registerAssetId("models/Desert1.fbx/Prefab/TreePalm1", "PREFAB_DESERT_TREE_PALM1")
mod:registerAssetId("models/Desert1.fbx/Prefab/TreePalm2", "PREFAB_DESERT_TREE_PALM2")
mod:registerAssetId("models/Desert1.fbx/Prefab/TreeCane", "PREFAB_DESERT_TREE_CANE")



-- Plantable -------------------------------------------------------------------------------------
mod:registerPrefabComponent("models/Desert1.fbx/Prefab/TreeDate", { DataType = "COMP_PLANTABLE", MinSpaceBetweenPlant = 14.0 })
mod:registerPrefabComponent("models/Desert1.fbx/Prefab/TreeDate", { DataType = "COMP_TREE" })

mod:register({
    DataType = "PLANTABLE",
    Id = "PLANTABLE_DESERT_TREE_DATE",
    Name = "PLANTABLE_DESERT_TREE_DATE_NAME",
    PlantPrefab = "PREFAB_DESERT_TREE_DATE",
    MinimumScale = 0.85, -- min size at full growth
    MaximumScale = 1.15 -- max size at full growth
})


mod:registerPrefabComponent("models/Desert1.fbx/Prefab/TreePalm1", { DataType = "COMP_PLANTABLE", MinSpaceBetweenPlant = 14.0 })
mod:registerPrefabComponent("models/Desert1.fbx/Prefab/TreePalm1", { DataType = "COMP_TREE" })

mod:register({
    DataType = "PLANTABLE",
    Id = "PLANTABLE_DESERT_TREE_PALM1",
    Name = "PLANTABLE_DESERT_TREE_PALM1_NAME",
    PlantPrefab = "PREFAB_DESERT_TREE_PALM1",
    MinimumScale = 0.85, -- min size at full growth
    MaximumScale = 1.15 -- max size at full growth
})


mod:registerPrefabComponent("models/Desert1.fbx/Prefab/TreePalm2", { DataType = "COMP_PLANTABLE", MinSpaceBetweenPlant = 14.0 })
mod:registerPrefabComponent("models/Desert1.fbx/Prefab/TreePalm2", { DataType = "COMP_TREE" })

mod:register({
    DataType = "PLANTABLE",
    Id = "PLANTABLE_DESERT_TREE_PALM2",
    Name = "PLANTABLE_DESERT_TREE_PALM2_NAME",
    PlantPrefab = "PREFAB_DESERT_TREE_PALM2",
    MinimumScale = 0.85, -- min size at full growth
    MaximumScale = 1.15 -- max size at full growth
})


mod:registerPrefabComponent("models/Desert1.fbx/Prefab/TreeCane", { DataType = "COMP_PLANTABLE", MinSpaceBetweenPlant = 14.0 })
mod:registerPrefabComponent("models/Desert1.fbx/Prefab/TreeCane", { DataType = "COMP_TREE" })

mod:register({
    DataType = "PLANTABLE",
    Id = "PLANTABLE_DESERT_TREE_CANE",
    Name = "PLANTABLE_DESERT_TREE_CANE_NAME",
    PlantPrefab = "PREFAB_DESERT_TREE_CANE",
    MinimumScale = 0.85, -- min size at full growth
    MaximumScale = 1.15 -- max size at full growth
})




-- Resource Container -------------------------------------------------------------------------------------
mod:registerPrefabComponent( "models/Desert1.fbx/Prefab/TreeDate", {
    DataType = "COMP_RESOURCE_CONTAINER",
    ResourceData = "BERRIES",
    IsReplenishable = true,
    ReplenishDurationInDays = 14,
    ReplenishQuantity = 2,
    ResourceValue = 2.0, -- how many are gathered with each pick
    AvailableQuantity = 2, -- maximum container stock
    Radius = 0.85, -- distance from container that the villager will stand to pick
    IsDestroyWhenEmpty = false,
    HasMaximumWorkstation = false
})


mod:registerPrefabComponent( "models/Desert1.fbx/Prefab/TreePalm1", {
    DataType = "COMP_RESOURCE_CONTAINER",
    ResourceData = "WOOD",
    IsReplenishable = false,
    ResourceValue = 1.0, -- how many are gathered with each pick
    AvailableQuantity = 1, -- maximum container stock
    Radius = 1.3, -- distance from container that the villager will stand to pick
    IsDestroyWhenEmpty = true,
    HasMaximumWorkstation = false
})


mod:registerPrefabComponent( "models/Desert1.fbx/Prefab/TreePalm2", {
    DataType = "COMP_RESOURCE_CONTAINER",
    ResourceData = "WOOD",
    IsReplenishable = false,
    ResourceValue = 1.0, -- how many are gathered with each pick
    AvailableQuantity = 1, -- maximum container stock
    Radius = 1.3, -- distance from container that the villager will stand to pick
    IsDestroyWhenEmpty = true,
    HasMaximumWorkstation = false
})


mod:registerPrefabComponent( "models/Desert1.fbx/Prefab/TreeCane", {
    DataType = "COMP_RESOURCE_CONTAINER",
    ResourceData = "WOOD",
    IsReplenishable = false,
    ResourceValue = 0.0, -- how many are gathered with each pick
    AvailableQuantity = 1, -- maximum container stock
    Radius = 1.3, -- distance from container that the villager will stand to pick
    IsDestroyWhenEmpty = true,
    HasMaximumWorkstation = false
})



-- registering map files
mod:registerAssetId("maps/heightmap.png", "HEIGHT_MAP")
mod:registerAssetId("maps/material_mask.png", "MATERIAL_MASK")
mod:registerAssetId("maps/palm_density.png", "PALM_DENSITY_MAP")
mod:registerAssetId("maps/berries_density.png", "BERRIES_DENSITY_MAP")
mod:registerAssetId("maps/rock_density.png", "ROCK_DENSITY_MAP")
mod:registerAssetId("maps/fish_density.png", "FISH_DENSITY_MAP")




-- register custom map
mod:register({
	DataType = "CUSTOM_MAP",
	Id = "MAP_NEGEVDESERT",
	HeightMap = "HEIGHT_MAP",
	MaterialMask = "MATERIAL_MASK",
	MinHeight = -5,
	MaxHeight = 70,
	VillagePathList = {
		{
			Entrance = { 100, 0, 1013 },
			Exit = { 100, 0, 13 },
		},
		{
			Entrance = { 200, 0, 1013 },
			Exit = { 200, 0, 13 },
		},
		{
			Entrance = { 300, 0, 1013 },
			Exit = { 300, 0, 13 },
		},
		{
			Entrance = { 400, 0, 1013 },
			Exit = { 299, 0, 12 },
		},
		{
			Entrance = { 500, 0, 1013 },
			Exit = { 500, 0, 13 },
		},
		{
			Entrance = { 600, 0, 1013 },
			Exit = { 600, 0, 13 },
		},
		{
			Entrance = { 700, 0, 1013 },
			Exit = { 700, 0, 13 },
		},
		{
			Entrance = { 800, 0, 1013 },
			Exit = { 800, 0, 13 },
		},
		{
			Entrance = { 900, 0, 1013 },
			Exit = { 900, 0, 13 },
		}
	},
	SpawnList = {
		{
			-- creating Mineral Deposit 1
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 219 , 16 , 110 },
			Orientation = { 0.0, 110.0 , 0.0},
			PatchBeforeVersion = "1.1.0"
		},
		{
			-- creating Mineral Deposit 2
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 564 , 11 , 239 },
			Orientation = { 0.0, -80.0 , 0.0},
			PatchBeforeVersion = "1.1.0"
		},
		{
			-- creating Mineral Deposit 3
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 632 , 11 , 509 },
			Orientation = { 0.0, -75.0 , 0.0},
			PatchBeforeVersion = "1.1.0"
		},
		{
			-- creating Mineral Deposit 4
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 466 , 11 , 672 },
			Orientation = { 0.0, 40.0 , 0.0},
			PatchBeforeVersion = "1.1.0"
		},
		{
			-- creating Mineral Deposit 5
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 682 , 20 , 798 },
			Orientation = { 0.0, -110.0 , 0.0},
			PatchBeforeVersion = "1.1.0"
		},
		{
			-- creating Mineral Deposit 6
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 424 , 40 , 887 },
			Orientation = { 0.0, -45.0 , 0.0},
			PatchBeforeVersion = "1.1.0"
		},
		{
			-- creating Mineral Deposit 7
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 731 , 28 , 480 },
			Orientation = { 0.0, -0.0 , 0.0},
			PatchBeforeVersion = "1.1.0"
		},
		{
			-- creating Mineral Deposit 8
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 720 , 40 , 902 },
			Orientation = { 0.0, -0.0 , 0.0},
			PatchBeforeVersion = "1.1.0"
		}
	},
	DensitySpawnList = {
		{
			-- Palm trees
			DensityMap = "PALM_DENSITY_MAP",
			Density = 0.9,
			PrefabConfigList = {
				{
						PrefabList = { "PREFAB_DESERT_TREE_PALM1" },
						RandomWeight = 0.6,
						OffsetSizeRange = {
							Min = 0.75,
							Max = 1.0
					},
						OrientationRange = {
							Min = { 0, -180, 0 },
							Max = { 0, 180, 0 }
					},
						ScaleRange = {
							Min = 0.85,
							Max = 1.15
					},
						ColorRange = {
							Min = { 0.8, 0.8, 0.8, 1 },
							Max = { 1, 1, 1, 1 }
					}
				},
				{
                    PrefabList = { "PREFAB_DESERT_TREE_PALM2" },
                    RandomWeight = 0.3,
                    OffsetSizeRange = {
                        Min = 0.75,
                        Max = 1.0
                },
                    OrientationRange = {
                        Min = { 0, -180, 0 },
                        Max = { 0, 180, 0 }
                },
                    ScaleRange = {
                        Min = 0.85,
                        Max = 1.15
                },
                    ColorRange = {
                        Min = { 0.8, 0.8, 0.8, 1 },
                        Max = { 1, 1, 1, 1 }
                }
            },
            {
                    PrefabList = { "PREFAB_DESERT_TREE_DATE" },
                    RandomWeight = 0.1,
                    OffsetSizeRange = {
                        Min = 0.75,
                        Max = 1.0
                },
                    OrientationRange = {
                        Min = { 0, -180, 0 },
                        Max = { 0, 180, 0 }
                },
                    ScaleRange = {
                        Min = 0.85,
                        Max = 1.15
                },
                    ColorRange = {
                        Min = { 0.8, 0.8, 0.8, 1 },
                        Max = { 1, 1, 1, 1 }
                }
            },
            {
                PrefabList = { "PREFAB_DESERT_TREE_CANE" },
                RandomWeight = 0.1,
                OffsetSizeRange = {
                    Min = 0.75,
                    Max = 1.0
            },
                OrientationRange = {
                    Min = { 0, -180, 0 },
                    Max = { 0, 180, 0 }
            },
                ScaleRange = {
                    Min = 0.85,
                    Max = 1.15
            },
                ColorRange = {
                    Min = { 0.8, 0.8, 0.8, 1 },
                    Max = { 1, 1, 1, 1 }
            }
        }
    }
		},
		{
			-- Create rock outcrops - stone resource
			DensityMap = "ROCK_DENSITY_MAP",
			Density =0.9,
			PrefabConfigList = {
				{
						PrefabList = { "PREFAB_RESOURCE_ROCK" },
						RandomWeight = 0.1,
						OffsetSizeRange = {
							Min = 0.75,
							Max = 1.0
					},
						OrientationRange = {
							Min = { 0, -180, 0 },
							Max = { 0, 180, 0 }
					},
						ScaleRange = {
							Min = 0.85,
							Max = 1.15
					},
						ColorRange = {
							Min = { 0.8, 0.8, 0.8, 1 },
							Max = { 1, 1, 1, 1 }
					}
				}
			}
		},
		{
			-- Create fish shoals
			DensityMap = "FISH_DENSITY_MAP",
			Density =0.9,
			PrefabConfigList = {
				{
						PrefabList = { "PREFAB_RESOURCE_FISH" },
						RandomWeight = 0.1,
						OffsetSizeRange = {
							Min = 0.75,
							Max = 1.0
					},
						OrientationRange = {
							Min = { 0, -180, 0 },
							Max = { 0, 180, 0 }
					},
						ScaleRange = {
							Min = 0.85,
							Max = 1.15
					},
						ColorRange = {
							Min = { 0.8, 0.8, 0.8, 1 },
							Max = { 1, 1, 1, 1 }
					}
				}
			}
		}
	}
})
-- This map was created with the help of the UFME
